#include "Basic.fx"

//-----------------------------------------------------------------------------
// Shader Instance Params
//-----------------------------------------------------------------------------
// xɕ`悷CX^X̍őliC#ƓlLq邱Ɓj
// 傫قǃptH[}Xǂ
// ől͎s̒萔WX^ɈˑiVF[_[f2.0̉256j
#define MAX_SHADER_INSTANCE_COUNT 100

// VF[_[CX^Xp̃p[^[i[pz
float4 ShaderInstanceParams0[MAX_SHADER_INSTANCE_COUNT];
float4 ShaderInstanceParams1[MAX_SHADER_INSTANCE_COUNT];

struct VertexShaderInput
{
    float4 Position : POSITION0;
    float2 TexCoord : TEXCOORD0;
    float3 Normal	: NORMAL0;
};

struct VertexShaderOutput
{
    float4 Position : POSITION0;
    float2 TexCoord : TEXCOORD0;
};


//-----------------------------------------------------------------------------
// e_VF[_[Ă΂鋤ʂ̒_
//=============================================================================
VertexShaderOutput VertexShaderCommon( VertexShaderInput input, float4 instanceParam0,
																float4 instanceParam1)
{
    VertexShaderOutput output;
    
    // _ϊ
    float3 pos_os = instanceParam0.xyz;
    float scale = instanceParam0.w;

	// Y𒆐Sɉ]
	float3 ps = input.Position * scale;
	float4 pos_ws;
	pos_ws.x = pos_os.x + (ps.x * cos(instanceParam1.z) - ps.z * sin(instanceParam1.z));
	pos_ws.y = pos_os.y + ps.y;
	pos_ws.z = pos_os.z + (ps.x * sin(instanceParam1.z) - ps.z * cos(instanceParam1.z));
	pos_ws.w = 1;

    float4 pos_vs = mul(pos_ws, View);
    output.Position = mul(pos_vs, Projection);

    // eNX`W̃ItZbgZ
    output.TexCoord = input.TexCoord + instanceParam1.xy;

    return output;
}

//-----------------------------------------------------------------------------
// VF[_[CX^X̒_VF[_[
// CX^XCfbNX͒_f[^Ɋi[Ă
//=============================================================================
VertexShaderOutput ShaderInstancingVS(VertexShaderInput input,
                                                float instanceIndex : TEXCOORD1)
{
    return VertexShaderCommon(input,
		ShaderInstanceParams0[instanceIndex],
		ShaderInstanceParams1[instanceIndex]);
}


//-----------------------------------------------------------------------------
// sNZVF[_[
//=============================================================================
float4 PS( VertexShaderOutput pin ) : COLOR0
{
	float4 color = tex2D(TextureSampler, pin.TexCoord);
	return color;
}

//-----------------------------------------------------------------------------
// eNjbN̐錾
//=============================================================================
technique ShaderInstancing
{
    pass Pass1
    {
        VertexShader = compile vs_2_0 ShaderInstancingVS();
        PixelShader = compile ps_1_1 PS();
    }
}

